"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _dvaNoRouter = require("dva-no-router");

require("./Checkbox.less");

var _checkCircleFill = _interopRequireDefault(require("../../assets/image/check-circle-fill.svg"));

var _checkSquareFill = _interopRequireDefault(require("../../assets/image/check-square-fill.svg"));

var _loading = _interopRequireDefault(require("../../assets/image/loading.svg"));

var _check_disabled = _interopRequireDefault(require("../../assets/image/check_disabled.svg"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Checkbox =
/*#__PURE__*/
function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox(props) {
    var _this;

    _classCallCheck(this, Checkbox);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Checkbox).call(this, props));
    _this.renderContent = _this.renderContent.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Checkbox, [{
    key: "renderDisabled",
    value: function renderDisabled() {
      var className = this.props.className;
      var checkboxCls = (0, _classnames.default)(['nbugs-component-checkbox', className]);
      return _react.default.createElement("div", {
        className: checkboxCls
      }, _react.default.createElement("img", {
        className: "check-box-checked",
        src: _check_disabled.default,
        alt: "disabled"
      }));
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this$props = this.props,
          className = _this$props.className,
          checked = _this$props.checked,
          intermediate = _this$props.intermediate,
          disabled = _this$props.disabled,
          loading = _this$props.loading,
          styleType = _this$props.styleType,
          themeImg = _this$props.themeImg;
      var checkboxCls = (0, _classnames.default)(['nbugs-component-checkbox', className]);

      if (loading) {
        return _react.default.createElement("div", {
          className: checkboxCls
        }, loading && _react.default.createElement("img", {
          className: (0, _classnames.default)('check-box-loading'),
          src: _loading.default,
          alt: "loading"
        }));
      } // 禁用状态


      if (disabled) {
        return this.renderDisabled();
      }

      var imgSrc = styleType === 'mobile' ? _checkCircleFill.default : _checkSquareFill.default;

      if (themeImg) {
        imgSrc = themeImg;
      }

      return _react.default.createElement("div", {
        className: checkboxCls
      }, styleType === 'mobile' && !checked && !intermediate && _react.default.createElement("div", {
        className: (0, _classnames.default)('check-box-default')
      }), styleType === 'pc' && !checked && !intermediate && _react.default.createElement("div", {
        className: (0, _classnames.default)('check-box-default-pc')
      }), checked && _react.default.createElement("img", {
        className: styleType === 'mobile' ? (0, _classnames.default)('check-box-checked') : (0, _classnames.default)('check-box-checked-pc'),
        src: imgSrc,
        alt: "checked"
      }), !checked && intermediate && _react.default.createElement("img", {
        className: styleType === 'mobile' ? (0, _classnames.default)('check-box-intermediate') : (0, _classnames.default)('check-box-intermediate-pc'),
        src: imgSrc,
        alt: "intermediate"
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return this.renderContent();
    }
  }]);

  return Checkbox;
}(_react.Component);

var _default = (0, _dvaNoRouter.connect)()(Checkbox);

exports.default = _default;