"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _dvaNoRouter = require("dva-no-router");

require("./TreeNode.less");

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _arrow_up = _interopRequireDefault(require("../../assets/image/arrow_up.svg"));

var _arrow_down = _interopRequireDefault(require("../../assets/image/arrow_down.svg"));

var _caretRight = _interopRequireDefault(require("../../assets/image/caret-right.svg"));

var _caretDown = _interopRequireDefault(require("../../assets/image/caret-down.svg"));

var _tree2 = require("../../utils/tree");

var _treePC = require("../../utils/treePC");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var loadChildDataPromise = null;

var _loadUserPromise = (0, _treePC.loadUserPromise)(),
    addPromises = _loadUserPromise.addPromises,
    getPromises = _loadUserPromise.getPromises;

var TreeNode =
/*#__PURE__*/
function (_Component) {
  _inherits(TreeNode, _Component);

  function TreeNode(props) {
    var _this;

    _classCallCheck(this, TreeNode);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TreeNode).call(this, props));
    _this.state = {
      renderFlag: false,
      loadChild: false,
      // 是否正在加载子节点
      hasLoadedChild: false,
      // 是否已经加载过子节点
      expanded: false // 是否自动

    };
    _this.renderContent = _this.renderContent.bind(_assertThisInitialized(_this));
    _this.handleFoldNode = _this.handleFoldNode.bind(_assertThisInitialized(_this));
    _this.handleCheck = _this.handleCheck.bind(_assertThisInitialized(_this));
    _this.handleParentUpdate = _this.handleParentUpdate.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(TreeNode, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.initialData(this.props);
      setTimeout(function () {
        var isExpand = _this2.isExpandNode();

        if (isExpand) {
          _this2.expandNode();
        }
      }, 0);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.initialData(nextProps);
    } // 是否默认展开当前节点

  }, {
    key: "isExpandNode",
    value: function isExpandNode() {
      var _this$props = this.props,
          treeNode = _this$props.treeNode,
          treeProps = _this$props.treeProps;
      var expandRootNode = treeProps.expandRootNode;
      var _parentIdList = treeNode._parentIdList;
      return expandRootNode && Array.isArray(_parentIdList) && !_parentIdList.length;
    } // 展开当前节点

  }, {
    key: "expandNode",
    value: function expandNode() {
      var hasLoadedChild = this.state.hasLoadedChild;
      var treeProps = this.props.treeProps;
      var loadData = treeProps.loadData;
      this.setState({
        expanded: true
      });

      if (!hasLoadedChild && typeof loadData === 'function') {
        loadChildDataPromise = this.loadChildData();
        addPromises(loadChildDataPromise);
      }
    }
  }, {
    key: "initialData",
    value: function initialData(props) {
      var _this3 = this;

      var treeNode = props.treeNode,
          treeProps = props.treeProps,
          updateCheckedNodes = props.updateCheckedNodes,
          updateIntermediateNodeKeys = props.updateIntermediateNodeKeys;
      var _id = treeNode._id,
          _checked = treeNode._checked;
      var dynamicCheckedId = treeProps.dynamicCheckedId,
          dynamicUnCheckedId = treeProps.dynamicUnCheckedId,
          expandedNodeKeys = treeProps.expandedNodeKeys,
          intermediateNodeKeys = treeProps.intermediateNodeKeys,
          checkedNodes = treeProps.checkedNodes,
          staticNodeKey = treeProps.staticNodeKey,
          dynamicNodeKey = treeProps.dynamicNodeKey,
          staticNodeTypeLabel = treeProps.staticNodeTypeLabel,
          dynamicNodeTypeLabel = treeProps.dynamicNodeTypeLabel;
      var expanded = expandedNodeKeys.some(function (item) {
        return item === _id;
      });

      if (updateIntermediateNodeKeys && !_checked) {
        var intermediated = (0, _tree2.nodeInteractionState)({
          type: 'intermediate',
          node: treeNode,
          comparateProp: treeNode._type === staticNodeTypeLabel ? staticNodeKey : dynamicNodeKey,
          intermediateNodeKeys: intermediateNodeKeys
        });

        if (intermediated) {
          treeNode._intermediate = true;
        }
      }

      if (updateCheckedNodes && !_checked) {
        var checked = (0, _tree2.nodeInteractionState)({
          type: 'checked',
          node: treeNode,
          nodeType: treeNode._type,
          comparateProp: treeNode._type === staticNodeTypeLabel ? staticNodeKey : dynamicNodeKey,
          attachedComparateProp: treeNode._type === dynamicNodeTypeLabel ? staticNodeKey : '',
          checkedNodes: checkedNodes
        });

        if (checked) {
          this.handleCheck();
        }
      }

      if (_id === dynamicCheckedId) {
        if (!_checked) {
          this.handleCheck();
        }

        var promises = getPromises();
        Promise.all(promises).finally(function () {
          _this3.scrollTree();
        });
      }

      if (_id === dynamicUnCheckedId) {
        if (_checked) {
          this.handleCheck();
        }
      }

      if (expanded) {
        this.expandNode();
      }
    } // 将树滚动至对应位置

  }, {
    key: "scrollTree",
    value: function scrollTree() {
      var ele = this.$treeNode;
      var wrapEle = document.getElementsByClassName('tree-wrap')[0];
      (0, _treePC.rollNodeToWhere)({
        ele: ele,
        wrapEle: wrapEle
      });
    } // 节点的展开/折叠

  }, {
    key: "handleFoldNode",
    value: function handleFoldNode(e) {
      var _this$state = this.state,
          expanded = _this$state.expanded,
          hasLoadedChild = _this$state.hasLoadedChild;
      var treeProps = this.props.treeProps;
      var loadData = treeProps.loadData;

      if (e && typeof e.stopPropagation === 'function') {
        e.stopPropagation();
      }

      if (typeof loadData !== 'function') {
        return this.setState({
          expanded: !expanded
        });
      }

      if (expanded) {
        return this.setState({
          expanded: false
        });
      }

      if (hasLoadedChild) {
        return this.setState({
          expanded: true
        });
      }

      this.loadChildData();
    } // 加载子节点数据

  }, {
    key: "loadChildData",
    value: function loadChildData() {
      var _this4 = this;

      var loadChild = this.state.loadChild;
      var _this$props2 = this.props,
          treeNode = _this$props2.treeNode,
          treeProps = _this$props2.treeProps;
      var _checked = treeNode._checked,
          _isLoaded = treeNode._isLoaded;
      var loadData = treeProps.loadData,
          loadDataFlag = treeProps.loadDataFlag,
          nodeFoldDetailProps = treeProps.nodeFoldDetailProps,
          checkedNodes = treeProps.checkedNodes,
          disabledNodeKeys = treeProps.disabledNodeKeys,
          loopStyle = treeProps.loopStyle;
      var params = {};

      if (_isLoaded || loadChild) {
        return false;
      }

      nodeFoldDetailProps.forEach(function (key) {
        params[key] = treeNode[key] || '';
      });

      if (treeNode[loadDataFlag]) {
        return this.setState({
          expanded: true,
          hasLoadedChild: true
        });
      }

      if (typeof loadData !== 'function') {
        return false;
      }

      this.setState({
        loadChild: true
      });
      return loadData(params).then(function (childList) {
        (0, _tree2.loadNodeChild)({
          node: treeNode,
          childList: childList,
          treeProps: treeProps,
          checkedNodes: checkedNodes,
          disabledNodeKeys: disabledNodeKeys
        });
        treeNode._isLoaded = true;

        _this4.setState({
          hasLoadedChild: true
        }); // 当 loopStyle 为 entire 时，展开非叶子节点，需要重新计算 changedNodes


        if (_checked && loopStyle === 'entire') {
          setTimeout(function () {
            _this4.handleNodesChange();
          }, 0);
        }
      }).catch(function (err) {
        throw new Error("loadData err: ".concat(err));
      }).finally(function () {
        _this4.setState({
          expanded: true,
          loadChild: false
        });
      });
    }
  }, {
    key: "handleNodesChange",
    value: function handleNodesChange() {
      var _this$props3 = this.props,
          treeNode = _this$props3.treeNode,
          _tree = _this$props3._tree,
          treeProps = _this$props3.treeProps,
          onNodesChange = _this$props3.onNodesChange;
      var onChange = treeProps.onChange,
          checkedNodeProps = treeProps.checkedNodeProps,
          dynamicNodeTypeLabel = treeProps.dynamicNodeTypeLabel,
          filterFunc = treeProps.filterFunc,
          loopStyle = treeProps.loopStyle;

      var _getChangedNodes = (0, _tree2.getChangedNodes)({
        checkedNodeProps: checkedNodeProps,
        dynamicNodeTypeLabel: dynamicNodeTypeLabel,
        _tree: _tree,
        checkedNodes: treeProps.checkedNodes,
        filterFunc: filterFunc,
        loopStyle: loopStyle
      }),
          checkedNodes = _getChangedNodes.checkedNodes,
          intermediateNodes = _getChangedNodes.intermediateNodes;

      var callbackData = {
        node: treeNode,
        checkedNodes: checkedNodes,
        intermediateNodes: intermediateNodes
      };

      if (typeof onNodesChange === 'function') {
        onNodesChange(callbackData);
      }

      if (typeof onChange === 'function') {
        onChange(callbackData);
      }
    } // 选中/取消选中 节点

  }, {
    key: "handleCheck",
    value: function handleCheck() {
      var _this5 = this;

      /* eslint-disable */
      var renderFlag = this.state.renderFlag;
      var _this$props4 = this.props,
          treeNode = _this$props4.treeNode,
          notifyParentUpdate = _this$props4.notifyParentUpdate,
          treeProps = _this$props4.treeProps;
      var disabledNodeKeys = treeProps.disabledNodeKeys,
          deptNodeCheckable = treeProps.deptNodeCheckable;
      var _checked = treeNode._checked,
          _children = treeNode._children,
          _id = treeNode._id,
          _type = treeNode._type;
      var state = !_checked;

      if (disabledNodeKeys.some(function (item) {
        return item === _id;
      })) {
        return false;
      }

      if (_type === 'dept' && !deptNodeCheckable) {
        return false;
      } // 更新自身节点状态


      treeNode._checked = state;
      treeNode._intermediate = false; // 更新后代节点状态

      (0, _tree2.loop)({
        list: _children
      }, function (item) {
        item._intermediate = false;
        item._checked = state;
        return {
          result: item._isLeaf ? null : item._children
        };
      }); // 通知父节点更新状态

      if (typeof notifyParentUpdate === 'function') {
        notifyParentUpdate();
      }

      this.setState({
        renderFlag: !renderFlag
      });
      setTimeout(function () {
        _this5.handleNodesChange();
      }, 0);
      /* eslint-enable */
    } // notifyParentUpdate 事件处理

  }, {
    key: "handleParentUpdate",
    value: function handleParentUpdate() {
      var _this6 = this;

      if (loadChildDataPromise && typeof loadChildDataPromise.then === 'function') {
        loadChildDataPromise.finally(function () {
          _this6.updateSelfState();
        });
      } else {
        this.updateSelfState();
      }
    } // 更新自身状态（由后代节点通知）

  }, {
    key: "updateSelfState",
    value: function updateSelfState() {
      var renderFlag = this.state.renderFlag;
      var _this$props5 = this.props,
          treeNode = _this$props5.treeNode,
          notifyParentUpdate = _this$props5.notifyParentUpdate;
      var _children = treeNode._children;
      var isAllChildChecked = true;
      var isAllChildUnChecked = true; // 确定自身状态

      for (var i = 0, item; item = _children[i]; i += 1) {
        if (item._intermediate) {
          isAllChildChecked = false;
          isAllChildUnChecked = false;
          break;
        }

        if (item._checked) {
          isAllChildUnChecked = false;
        } else {
          isAllChildChecked = false;
        }
      }

      treeNode._checked = isAllChildChecked;
      treeNode._intermediate = !isAllChildChecked && !isAllChildUnChecked; // 将更新请求冒泡到父节点

      if (typeof notifyParentUpdate === 'function') {
        notifyParentUpdate();
      }

      this.setState({
        renderFlag: !renderFlag
      });
    }
  }, {
    key: "renderCheckbox",
    value: function renderCheckbox() {
      var _this$props6 = this.props,
          treeNode = _this$props6.treeNode,
          treeProps = _this$props6.treeProps;
      var platform = treeProps.platform,
          showCheckbox = treeProps.showCheckbox,
          deptNodeCheckable = treeProps.deptNodeCheckable,
          themeImg = treeProps.themeImg;
      var loadChild = this.state.loadChild;
      var _disabled = treeNode._disabled,
          _type = treeNode._type;

      if (!showCheckbox || !deptNodeCheckable && _type === 'dept') {
        return null;
      }

      return _react.default.createElement(_Checkbox.default, {
        checked: treeNode._checked,
        intermediate: treeNode._intermediate,
        disabled: _disabled,
        loading: loadChild,
        styleType: platform,
        themeImg: themeImg
      });
    }
  }, {
    key: "renderFoldIcon",
    value: function renderFoldIcon() {
      var _this$props7 = this.props,
          treeNode = _this$props7.treeNode,
          treeProps = _this$props7.treeProps;
      var expanded = this.state.expanded;
      var platform = treeProps.platform,
          isTag = treeProps.isTag;

      if (isTag) {
        return '';
      }

      return !treeNode._isLeaf && _react.default.createElement("div", {
        className: platform === 'mobile' ? (0, _classnames.default)('tree-node-icon-wrap-mobile') : (0, _classnames.default)('tree-node-icon-wrap-pc'),
        onClick: this.handleFoldNode
      }, platform === 'mobile' && _react.default.createElement("img", {
        className: (0, _classnames.default)('tree-node-icon-mobile'),
        src: expanded ? _arrow_up.default : _arrow_down.default,
        alt: "arrow"
      }), platform === 'pc' && _react.default.createElement("img", {
        className: (0, _classnames.default)('tree-node-icon-pc'),
        src: expanded ? _caretDown.default : _caretRight.default,
        alt: "arrow"
      }));
    }
  }, {
    key: "renderMobile",
    value: function renderMobile() {
      var _this$props8 = this.props,
          treeNode = _this$props8.treeNode,
          treeProps = _this$props8.treeProps;
      var cls = (0, _classnames.default)(['tree-node-wrap', 'tree-node-wrap-mobile']);

      if (treeProps.isTag) {
        treeNode.istag = treeProps.isTag;
      }

      return _react.default.createElement("div", {
        className: cls,
        onClick: this.handleCheck
      }, this.renderCheckbox(), _react.default.createElement("div", {
        style: {
          width: '100%'
        }
      }, treeProps.renderNodeText && typeof treeProps.renderNodeText === 'function' ? treeProps.renderNodeText(treeNode) : _react.default.createElement("span", {
        className: (0, _classnames.default)('tree-node-label'),
        style: {
          maxWidth: '150px'
        }
      }, treeNode._name)), this.renderFoldIcon());
    }
  }, {
    key: "renderPC",
    value: function renderPC() {
      var _this7 = this;

      var _this$props9 = this.props,
          treeNode = _this$props9.treeNode,
          treeProps = _this$props9.treeProps;
      var cls = (0, _classnames.default)(['tree-node-wrap', 'tree-node-wrap-pc']);

      if (treeProps.isTag) {
        treeNode.istag = treeProps.isTag;
      }

      return _react.default.createElement("div", {
        className: cls,
        onClick: this.handleCheck,
        ref: function ref(_ref) {
          _this7.$treeNode = _ref;
        }
      }, this.renderFoldIcon(), this.renderCheckbox(), _react.default.createElement("div", {
        style: {
          width: '100%'
        }
      }, treeProps.renderNodeText && typeof treeProps.renderNodeText === 'function' ? treeProps.renderNodeText(treeNode) : _react.default.createElement("span", {
        className: (0, _classnames.default)('tree-node-label'),
        style: {
          maxWidth: '190px'
        }
      }, treeNode._name, treeProps.isTag ? "(".concat(treeNode.count || 0, ")") : '')));
    } // 渲染子节点

  }, {
    key: "renderChildren",
    value: function renderChildren() {
      var _this8 = this;

      var expanded = this.state.expanded;
      var _this$props10 = this.props,
          treeNode = _this$props10.treeNode,
          _tree = _this$props10._tree,
          updateCheckedNodes = _this$props10.updateCheckedNodes,
          updateIntermediateNodeKeys = _this$props10.updateIntermediateNodeKeys,
          _this$props10$treePro = _this$props10.treeProps,
          treeProps = _this$props10$treePro === void 0 ? {} : _this$props10$treePro,
          resetHighlightId = _this$props10.resetHighlightId,
          onNodesChange = _this$props10.onNodesChange;
      var _isLeaf = treeNode._isLeaf,
          _children = treeNode._children;
      var className = _isLeaf || !expanded ? 'tree-node-children-hidden' : 'tree-node-children';
      return _react.default.createElement("div", {
        className: (0, _classnames.default)(className)
      }, !_isLeaf && _children.map(function (item) {
        var _id = item._id,
            _item$role = item.role,
            role = _item$role === void 0 ? '' : _item$role;
        return _react.default.createElement(TreeNode, {
          key: _id + role,
          className: "tree-node-component",
          treeNode: item,
          treeProps: treeProps,
          _tree: _tree,
          updateCheckedNodes: updateCheckedNodes,
          updateIntermediateNodeKeys: updateIntermediateNodeKeys,
          notifyParentUpdate: _this8.handleParentUpdate,
          resetHighlightId: resetHighlightId,
          onNodesChange: onNodesChange
        });
      }));
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this$props11 = this.props,
          className = _this$props11.className,
          treeProps = _this$props11.treeProps;
      var platform = treeProps.platform;
      var treeNodeCls = (0, _classnames.default)(['nbugs-component-tree-node', className]);
      return _react.default.createElement("div", {
        className: treeNodeCls
      }, platform === 'mobile' ? this.renderMobile() : this.renderPC(), this.renderChildren());
    }
  }, {
    key: "render",
    value: function render() {
      return this.renderContent();
    }
  }]);

  return TreeNode;
}(_react.Component);

var _default = (0, _dvaNoRouter.connect)(function (_ref2) {
  var global = _ref2.global,
      rest = _objectWithoutProperties(_ref2, ["global"]);

  return {
    _tree: rest.tree._tree,
    updateCheckedNodes: rest.tree.updateCheckedNodes,
    updateIntermediateNodeKeys: rest.tree.updateIntermediateNodeKeys
  };
})(TreeNode);

exports.default = _default;