"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _tree = require("./service/tree");

var _component = require("./component.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var corpid = 'wx981d0202130ed8e7'; // const checkedNodes = [
//   {
//     deptId: '330108-S000018-D000002',
//     deptName: '所有老师',
//     type: 'user',
//     userId: 'FB37CA2221F7478BA3AFE9CCFF484F8E',
//     userName: '王辉',
//     userType: '',
//   },
// ];

var checkedNodes = []; // const intermediateNodeKeys = [
//   '330108-S000018',
//   '405D2AE0E3FD5C01FC0B143C7D5A9760',
//   '330108-S000018-D000002',
// ];

var intermediateNodeKeys = [];
var disabledNodeKeys = [];

var Test =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Test, _React$Component);

  function Test(props) {
    var _this;

    _classCallCheck(this, Test);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Test).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "filterNodes", function (originNodes) {
      var _nodes = originNodes.map(function (item) {
        var type = item.type;

        if (type === 'dept') {
          delete item.userId;
          delete item.userName;
          delete item.userType;
        } else if (type === 'user') {
          delete item.memberRole;
          delete item.deptType;
        }

        return item;
      });

      return _nodes;
    });

    _defineProperty(_assertThisInitialized(_this), "handleConfirm", function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$checkedNodes = _ref.checkedNodes,
          checkedNodes = _ref$checkedNodes === void 0 ? [] : _ref$checkedNodes,
          _ref$intermediateNode = _ref.intermediateNodes,
          intermediateNodes = _ref$intermediateNode === void 0 ? [] : _ref$intermediateNode;

      var _checkedList = _this.filterNodes(checkedNodes);

      var deptList = _checkedList.filter(function (item) {
        return item.type === 'dept';
      });

      var userList = _checkedList.filter(function (item) {
        return item.type === 'user';
      });

      _this.filterNodes(intermediateNodes);

      console.log('​Test -> statichandleConfirm -> deptList', deptList);
      console.log('​Test -> statichandleConfirm -> userList', userList);
      console.log('​Test -> statichandleConfirm -> intermediateNodes', intermediateNodes);
      console.log('​Test -> statichandleConfirm -> checkedNodes', checkedNodes);
    });

    _defineProperty(_assertThisInitialized(_this), "handleCancel", function () {
      console.log('点击了取消按钮');
    });

    _defineProperty(_assertThisInitialized(_this), "fetchDepartUser", function (params) {
      var deptId = params.deptId,
          deptType = params.deptType,
          deptName = params.deptName;
      return (0, _tree.getDepartUser)({
        corpid: corpid,
        deptId: deptId,
        deptType: deptType
      }).then(function (data) {
        var _data$users = data.users,
            users = _data$users === void 0 ? [] : _data$users;
        return users.map(function (item) {
          var userId = item.userId,
              userName = item.userName,
              _item$userType = item.userType,
              userType = _item$userType === void 0 ? '' : _item$userType;
          return {
            userId: userId,
            userName: userName,
            userType: userType,
            deptId: deptId,
            deptName: deptName,
            deptType: deptType
          };
        });
      });
    });

    _this.treeRef = null;
    _this.state = {
      sourceList: []
    };
    return _this;
  }

  _createClass(Test, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.fetchTree();
    }
  }, {
    key: "fetchTree",
    value: function fetchTree() {
      var _this2 = this;

      var requestParams = {
        haveAuthority: false,
        corpid: corpid
      };
      (0, _tree.getAddress)(requestParams).then(function (data) {
        var treeData = data.rootDepartments;

        _this2.setState({
          sourceList: treeData
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var checkedNodeProps = ['deptId', 'deptName', 'memberRole', 'userId', 'userName', 'userType', 'deptType'];
      var nodeFoldDetailProps = ['deptId', 'deptName', 'deptType'];
      var sourceList = this.state.sourceList;

      if (!sourceList.length) {
        return null;
      }

      return _react.default.createElement("div", {
        style: {
          height: '100%'
        }
      }, _react.default.createElement(_component.Tree, {
        ref: function ref(_ref2) {
          _this3.treeRef = _ref2;
        },
        treeData: sourceList,
        staticNodeLabel: "deptName",
        dynamicNodeLabel: "userName",
        staticNodeKey: "deptId",
        dynamicNodeKey: "userId",
        child: "subDepts",
        platform: "mobile" // pc/mobile
        // deptNodeCheckable={false}
        ,
        checkedNodeProps: checkedNodeProps,
        checkedNodes: checkedNodes,
        disabledNodeKeys: disabledNodeKeys,
        intermediateNodeKeys: intermediateNodeKeys // loadData={null}
        ,
        nodeFoldDetailProps: nodeFoldDetailProps // loopStyle="entire"
        ,
        loadData: this.fetchDepartUser,
        onCancel: this.handleCancel,
        onOk: this.handleConfirm
      }));
    }
  }]);

  return Test;
}(_react.default.Component);

_reactDom.default.render(_react.default.createElement(Test, null), document.getElementById('root'));