"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _tree = require("./service/tree");

var _component = require("./component.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var corpid = 'wx981d0202130ed8e7'; // const checkedNodes = [
//   {
//     deptId: '086A8D4C1D1A4CCCBAD59A83E63F6B25',
//     deptName: '教职工组',
//     deptType: 'schoolworker_group',
//     type: 'user',
//     userId: '06A229E7D13D400EAA54FDDDCA4EBE52',
//     userName: '周信',
//     userType: '',
//   },
//   {
//     deptId: '3C4E78BE4ACF47B3B677715E3CB46B46',
//     deptName: '学生组',
//     deptType: 'student_group',
//     memberRole: '',
//     type: 'dept',
//   },
// ];

var checkedNodes = []; // const intermediateNodeKeys = [
//   '330108-S000018',
//   '381BBDDDD6AC43198CF01C88FE8BC17D',
//   '086A8D4C1D1A4CCCBAD59A83E63F6B25',
// ];

var intermediateNodeKeys = [];
var disabledNodeKeys = []; // const expandedNodeKeys = [];

var Test =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Test, _React$Component);

  _createClass(Test, null, [{
    key: "fetchDepartUser",
    value: function fetchDepartUser(params) {
      var deptId = params.deptId,
          deptType = params.deptType,
          deptName = params.deptName;
      return (0, _tree.getDepartUser)({
        corpid: corpid,
        deptId: deptId,
        deptType: deptType
      }).then(function (data) {
        var _data$users = data.users,
            users = _data$users === void 0 ? [] : _data$users;
        return users.map(function (item) {
          var userId = item.userId,
              userName = item.userName,
              _item$userType = item.userType,
              userType = _item$userType === void 0 ? '' : _item$userType;
          return {
            userId: userId,
            userName: userName,
            userType: userType,
            deptId: deptId,
            deptName: deptName,
            deptType: deptType
          };
        });
      });
    }
  }, {
    key: "filterNodes",
    value: function filterNodes(originNodes) {
      var _nodes = originNodes.map(function (item) {
        var type = item.type;

        if (type === 'dept') {
          delete item.userId;
          delete item.userName;
          delete item.userType;
        } else if (type === 'user') {
          delete item.memberRole;
          delete item.deptType;
        }

        return item;
      });

      return _nodes;
    }
  }, {
    key: "beforeNodeChange",
    value: function beforeNodeChange(_ref) {
      var node = _ref.node,
          checkedNodes = _ref.checkedNodes;
      console.log('TCL: Test -> staticbeforeNodeChange -> checkedNodes', checkedNodes);
      console.log('TCL: Test -> staticbeforeNodeChange -> node', node);
      return true;
    }
  }, {
    key: "handleConfirm",
    value: function handleConfirm() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref2$checkedNodes = _ref2.checkedNodes,
          checkedNodes = _ref2$checkedNodes === void 0 ? [] : _ref2$checkedNodes,
          _ref2$intermediateNod = _ref2.intermediateNodes,
          intermediateNodes = _ref2$intermediateNod === void 0 ? [] : _ref2$intermediateNod;

      var _checkedList = Test.filterNodes(checkedNodes);

      var deptList = _checkedList.filter(function (item) {
        return item.type === 'dept';
      });

      var userList = _checkedList.filter(function (item) {
        return item.type === 'user';
      });

      Test.filterNodes(intermediateNodes);
      console.log('​Test -> statichandleConfirm -> deptList', deptList);
      console.log('​Test -> statichandleConfirm -> userList', userList);
      console.log('​Test -> statichandleConfirm -> intermediateNodes', intermediateNodes);
      console.log('​Test -> statichandleConfirm -> checkedNodes', checkedNodes);
    }
  }, {
    key: "handleCancel",
    value: function handleCancel() {
      console.log('点击了取消按钮');
    }
  }, {
    key: "filterFunc",
    value: function filterFunc(node) {
      var deptType = node.deptType;
      return deptType === 'general_class';
    }
  }, {
    key: "searchNodeByKey",
    value: function searchNodeByKey() {
      // 7B300B2163874130899B76BF5ECB58ED
      console.log((0, _component.getNodesByKey)({
        key: '总务处'
      }));
    }
  }]);

  function Test(props) {
    var _this;

    _classCallCheck(this, Test);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Test).call(this, props));
    _this.state = {
      sourceList: [],
      expandedNodeKeys: [],
      highlightId: '',
      dynamicCheckedId: ''
    };
    return _this;
  }

  _createClass(Test, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.fetchTree();
    }
  }, {
    key: "fetchTree",
    value: function fetchTree() {
      var _this2 = this;

      (0, _tree.getAddress)({
        corpid: corpid
      }).then(function (data) {
        var treeData = data.rootDepartments;

        _this2.setState({
          sourceList: treeData
        });
      });
    }
  }, {
    key: "selectDept",
    value: function selectDept() {
      this.setState({
        expandedNodeKeys: ['330108-S000018', '381BBDDDD6AC43198CF01C88FE8BC17D', '086A8D4C1D1A4CCCBAD59A83E63F6B25'],
        dynamicCheckedId: '77A1E49F4CA54ED9A52792A048228B92'
      });
    }
  }, {
    key: "selectUser",
    value: function selectUser() {
      this.setState({
        expandedNodeKeys: ['330108-S000018', 'AF5F4EF1ED934BB8A4232B035FDECA82', '081D4F6EC46F4328AA495F0C0BEE6838'],
        dynamicCheckedId: '65DC2DBD9FB34903AC405605FEE7EB1A'
      });
    }
  }, {
    key: "render",
    value: function render() {
      var checkedNodeProps = ['deptId', 'deptName', 'memberRole', 'userId', 'userName', 'userType', 'deptType'];
      var nodeFoldDetailProps = ['deptId', 'deptName', 'deptType'];
      var _this$state = this.state,
          sourceList = _this$state.sourceList,
          expandedNodeKeys = _this$state.expandedNodeKeys,
          highlightId = _this$state.highlightId,
          dynamicCheckedId = _this$state.dynamicCheckedId;

      if (!sourceList.length) {
        return null;
      }

      return _react.default.createElement("div", {
        style: {
          height: '100%'
        }
      }, _react.default.createElement(_component.Tree, {
        treeData: sourceList,
        staticNodeLabel: "deptName",
        dynamicNodeLabel: "userName",
        staticNodeKey: "deptId",
        dynamicNodeKey: "userId",
        child: "subDepts",
        platform: "pc" // pc/mobile
        // deptNodeCheckable={false}
        ,
        checkedNodeProps: checkedNodeProps,
        checkedNodes: checkedNodes,
        intermediateNodeKeys: intermediateNodeKeys,
        expandedNodeKeys: expandedNodeKeys,
        disabledNodeKeys: disabledNodeKeys,
        highlightId: highlightId,
        dynamicCheckedId: dynamicCheckedId,
        loadData: Test.fetchDepartUser // loadData={null}
        ,
        nodeFoldDetailProps: nodeFoldDetailProps // beforeNodeChange={Test.beforeNodeChange}
        // filterFunc={Test.filterFunc}
        // loopStyle="entire"
        ,
        onCancel: Test.handleCancel,
        onOk: Test.handleConfirm
      }), _react.default.createElement("p", {
        style: {
          margin: '30px'
        },
        onClick: this.selectDept.bind(this)
      }, "\u9009\u4E2D\u90E8\u95E8"), _react.default.createElement("p", {
        style: {
          margin: '30px'
        },
        onClick: this.selectUser.bind(this)
      }, "\u9009\u4E2D\u4EBA\u5458"), _react.default.createElement("p", {
        style: {
          margin: '30px'
        },
        onClick: Test.searchNodeByKey.bind(this)
      }, "\u641C\u7D22\u90E8\u95E8\u8282\u70B9"));
    }
  }]);

  return Test;
}(_react.default.Component);

_reactDom.default.render(_react.default.createElement(Test, null), document.getElementById('root'));