"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./Tree.less");

var _dvaNoRouter = require("dva-no-router");

var _tree2 = require("../../utils/tree");

var _treePC = require("../../utils/treePC");

var _TreeNode = _interopRequireDefault(require("../../components/TreeNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var _loadUserPromise = (0, _treePC.loadUserPromise)(),
    getPromises = _loadUserPromise.getPromises,
    clearPromises = _loadUserPromise.clearPromises;

var App =
/*#__PURE__*/
function (_Component) {
  _inherits(App, _Component);

  function App(props) {
    var _this;

    _classCallCheck(this, App);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(App).call(this, props));
    _this.state = {
      okBtnDisabled: true
    };
    _this.renderContent = _this.renderContent.bind(_assertThisInitialized(_this));
    _this.handleCancel = _this.handleCancel.bind(_assertThisInitialized(_this));
    _this.handleConfirm = _this.handleConfirm.bind(_assertThisInitialized(_this));
    _this.resetHighlightId = _this.resetHighlightId.bind(_assertThisInitialized(_this));
    _this.handleNodesChange = _this.handleNodesChange.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(App, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var componentProps = this.props.componentProps;
      var checkedNodes = componentProps.checkedNodes;
      this.setState({
        okBtnDisabled: !checkedNodes.length
      });
    } // Tree更新完成之后，reset 受控属性

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var componentProps = this.props.componentProps;
      var promises = getPromises();

      if (Array.isArray(promises) && promises.length) {
        Promise.all(promises).finally(function () {
          componentProps.dynamicCheckedId = '';
          componentProps.dynamicUnCheckedId = '';
          componentProps.expandedNodeKeys = [];
          clearPromises();
        });
      } else {
        componentProps.dynamicCheckedId = '';
        componentProps.dynamicUnCheckedId = '';
        componentProps.expandedNodeKeys = [];
      }
    } // 取消

  }, {
    key: "handleCancel",
    value: function handleCancel() {
      var componentProps = this.props.componentProps;
      var onCancel = componentProps.onCancel;

      if (typeof onCancel === 'function') {
        onCancel();
      }
    } // 完成人员选择

  }, {
    key: "handleConfirm",
    value: function handleConfirm() {
      var okBtnDisabled = this.state.okBtnDisabled;
      var _this$props = this.props,
          componentProps = _this$props.componentProps,
          _tree = _this$props._tree;
      var onOk = componentProps.onOk,
          filterFunc = componentProps.filterFunc,
          loopStyle = componentProps.loopStyle,
          dynamicNodeTypeLabel = componentProps.dynamicNodeTypeLabel,
          _componentProps$check = componentProps.checkedNodeProps,
          checkedNodeProps = _componentProps$check === void 0 ? [] : _componentProps$check;

      if (okBtnDisabled) {
        return null;
      }

      if (typeof onOk === 'function') {
        var _getChangedNodes = (0, _tree2.getChangedNodes)({
          checkedNodeProps: checkedNodeProps,
          filterFunc: filterFunc,
          loopStyle: loopStyle,
          _tree: _tree,
          checkedNodes: componentProps.checkedNodes,
          dynamicNodeTypeLabel: dynamicNodeTypeLabel
        }),
            checkedNodes = _getChangedNodes.checkedNodes,
            intermediateNodes = _getChangedNodes.intermediateNodes;

        onOk({
          checkedNodes: checkedNodes,
          intermediateNodes: intermediateNodes
        });
      }
    }
  }, {
    key: "resetHighlightId",
    value: function resetHighlightId() {
      var dispatch = this.props.dispatch;
      dispatch({
        type: 'tree/resetHighlightId'
      });
    }
  }, {
    key: "handleNodesChange",
    value: function handleNodesChange(_ref) {
      var checkedNodes = _ref.checkedNodes;
      this.setState({
        okBtnDisabled: !checkedNodes.length
      });
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this2 = this;

      var okBtnDisabled = this.state.okBtnDisabled;
      var _this$props2 = this.props,
          componentProps = _this$props2.componentProps,
          _tree = _this$props2._tree;
      var className = componentProps.className,
          showOptionsBtn = componentProps.showOptionsBtn,
          themeColor = componentProps.themeColor;
      var treeCls = (0, _classnames.default)(['nbugs-component-tree', className]);

      if (!_tree.length) {
        return null;
      }

      return _react.default.createElement("div", {
        className: treeCls
      }, _react.default.createElement("div", {
        className: (0, _classnames.default)('tree-wrap')
      }, _tree.map(function (item) {
        return _react.default.createElement(_TreeNode.default, {
          key: item._id,
          treeNode: item,
          treeProps: componentProps,
          resetHighlightId: _this2.resetHighlightId,
          onNodesChange: _this2.handleNodesChange
        });
      })), showOptionsBtn && _react.default.createElement("div", {
        className: (0, _classnames.default)('btn-group')
      }, _react.default.createElement("div", {
        className: (0, _classnames.default)('btn-cancel'),
        onClick: this.handleCancel
      }, "\u53D6\u6D88"), _react.default.createElement("div", {
        className: okBtnDisabled ? (0, _classnames.default)(['btn-ok', 'btn-disabled']) : (0, _classnames.default)('btn-ok'),
        style: {
          background: themeColor
        },
        onClick: this.handleConfirm
      }, "\u786E\u5B9A")));
    }
  }, {
    key: "render",
    value: function render() {
      return this.renderContent();
    }
  }]);

  return App;
}(_react.Component);

var _default = (0, _dvaNoRouter.connect)(function (_ref2) {
  var global = _ref2.global,
      rest = _objectWithoutProperties(_ref2, ["global"]);

  return _objectSpread({}, global, rest.tree);
})(App);

exports.default = _default;