"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Tree = _interopRequireDefault(require("./Tree"));

var _dva = _interopRequireDefault(require("../../dva/dva"));

var _treePC = require("../../utils/treePC");

var _tree2 = require("../../utils/tree");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TreeWrap =
/*#__PURE__*/
function (_Component) {
  _inherits(TreeWrap, _Component);

  /* eslint-disable react/require-default-props, react/no-unused-prop-types */

  /* eslint-enable */
  function TreeWrap(_props) {
    var _this;

    _classCallCheck(this, TreeWrap);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TreeWrap).call(this, _props));

    _defineProperty(_assertThisInitialized(_this), "getNodesByKey", function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$key = _ref.key,
          key = _ref$key === void 0 ? '' : _ref$key,
          _ref$total = _ref.total,
          total = _ref$total === void 0 ? 10 : _ref$total;

      var app = _this.dvaInstance.app;

      var treeState = app._store.getState().tree;

      var _tree = treeState._tree,
          componentProps = treeState.componentProps;
      var staticNodeTypeLabel = componentProps.staticNodeTypeLabel;
      return (0, _treePC.getNodesByKey)({
        _tree: _tree,
        key: key,
        total: total,
        staticNodeTypeLabel: staticNodeTypeLabel
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getChangedNodes", function () {
      var app = _this.dvaInstance.app;

      var treeState = app._store.getState().tree;

      var _tree = treeState._tree,
          componentProps = treeState.componentProps;
      var checkedNodeProps = componentProps.checkedNodeProps,
          dynamicNodeTypeLabel = componentProps.dynamicNodeTypeLabel,
          checkedNodes = componentProps.checkedNodes,
          filterFunc = componentProps.filterFunc,
          loopStyle = componentProps.loopStyle,
          uncheckNode = componentProps.uncheckNode,
          callbackUncheck = componentProps.callbackUncheck;
      return (0, _tree2.getChangedNodes)({
        checkedNodeProps: checkedNodeProps,
        dynamicNodeTypeLabel: dynamicNodeTypeLabel,
        _tree: _tree,
        filterFunc: filterFunc,
        loopStyle: loopStyle,
        checkedNodes: checkedNodes,
        uncheckNode: uncheckNode,
        callbackUncheck: callbackUncheck
      });
    });

    _defineProperty(_assertThisInitialized(_this), "loadUserPromise", function () {
      return (0, _treePC.loadUserPromise)();
    });

    _defineProperty(_assertThisInitialized(_this), "handleUpdateState", function (props, init) {
      var app = _this.dvaInstance.app;

      app._store.dispatch({
        type: 'tree/initialData',
        payload: {
          props: props,
          init: init
        }
      }); // 首次不执行 && uncheckNode有数据才调用


      if (!init && props.uncheckNode) {
        _this.getChangedNodes();
      }
    });

    _this.dvaInstance = (0, _dva.default)(_react.default.createElement(_Tree.default, null));

    _this.handleUpdateState(_props, true);

    return _this;
  }

  _createClass(TreeWrap, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.handleUpdateState(nextProps, false);
    } // 根据节点名称或者是节点id搜索

  }, {
    key: "render",
    value: function render() {
      var _this$dvaInstance = this.dvaInstance,
          Provider = _this$dvaInstance.Provider,
          app = _this$dvaInstance.app;
      return _react.default.createElement(Provider, {
        store: app._store
      }, _react.default.createElement(_Tree.default, null));
    }
  }]);

  return TreeWrap;
}(_react.Component);

exports.default = TreeWrap;

_defineProperty(TreeWrap, "propTypes", {
  treeData: _propTypes.default.arrayOf(_propTypes.default.object).isRequired,
  child: _propTypes.default.string.isRequired,
  platform: _propTypes.default.oneOf(['pc', 'mobile']).isRequired,
  staticNodeLabel: _propTypes.default.string.isRequired,
  dynamicNodeLabel: _propTypes.default.string.isRequired,
  staticNodeKey: _propTypes.default.string.isRequired,
  dynamicNodeKey: _propTypes.default.string.isRequired,
  checkedNodeProps: _propTypes.default.arrayOf(_propTypes.default.string).isRequired,
  nodeFoldDetailProps: _propTypes.default.array,
  staticNodeTypeLabel: _propTypes.default.string,
  dynamicNodeTypeLabel: _propTypes.default.string,
  loadData: _propTypes.default.func,
  loadDataFlag: _propTypes.default.string,
  filterFunc: _propTypes.default.func,
  loopStyle: _propTypes.default.oneOf(['default', 'entire']),
  showOptionsBtn: _propTypes.default.bool,
  showCheckbox: _propTypes.default.bool,
  expandRootNode: _propTypes.default.bool,
  deptNodeCheckable: _propTypes.default.bool,
  checkedNodes: _propTypes.default.array,
  intermediateNodeKeys: _propTypes.default.array,
  expandedNodeKeys: _propTypes.default.array,
  disabledNodeKeys: _propTypes.default.array,
  dynamicCheckedId: _propTypes.default.string,
  dynamicUnCheckedId: _propTypes.default.string,
  onOk: _propTypes.default.func,
  onCancel: _propTypes.default.func,
  onChange: _propTypes.default.func,
  className: _propTypes.default.string,
  themeColor: _propTypes.default.string,
  themeImg: _propTypes.default.object,
  renderNodeText: _propTypes.default.func
});