"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _tree = require("../../utils/tree");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initState = {
  componentProps: {
    checkedNodes: [],
    intermediateNodeKeys: [],
    expandedNodeKeys: [],
    disabledNodeKeys: [],
    dynamicCheckedId: '',
    dynamicUnCheckedId: '',
    nodeFoldDetailProps: [],
    deptNodeCheckable: true,
    showCheckbox: true,
    showOptionsBtn: true,
    expandRootNode: true,
    onOk: null,
    onCancel: null,
    onChange: null,
    filterFunc: null,
    loopStyle: 'default',
    loadData: null,
    loadDataFlag: '',
    staticNodeTypeLabel: 'dept',
    dynamicNodeTypeLabel: 'user',
    className: '',
    themeColor: '#1786EC',
    themeImg: null
  },
  updateCheckedNodes: false,
  // 告知TreeNode是否需要care checkedNodes
  updateIntermediateNodeKeys: false,
  // 告知TreeNode是否需要care checkedNodes
  _tree: [] // 树的本地缓存数据

};
var _default = {
  namespace: 'tree',
  state: initState,
  effects: {},
  reducers: {
    resetState: function resetState() {
      return initState;
    },
    saveState: function saveState(state, _ref) {
      var payload = _ref.payload;
      return _objectSpread({}, state, payload);
    },
    // 初始化数据
    initialData: function initialData(state, _ref2) {
      var payload = _ref2.payload;
      var props = payload.props,
          init = payload.init;
      var treeData = props.treeData,
          checkedNodes = props.checkedNodes;
      var componentProps = Object.assign({}, state.componentProps, props);
      var updateCheckedNodes = !(0, _lodash.isEqual)(state.componentProps.checkedNodes, props.checkedNodes);
      var updateIntermediateNodeKeys = !(0, _lodash.isEqual)(state.componentProps.intermediateNodeKeys, props.intermediateNodeKeys);

      function treeItem(obj, checkData) {
        var _obj = Object.assign({}, obj); // eslint-disable-next-line guard-for-in


        for (var i in _obj) {
          if (checkData[props.staticNodeKey] === _obj[i][props.staticNodeKey]) {
            if (_obj[i][props.child]) {
              _obj[i][props.child].push(checkData);
            }
          }

          if (_obj[i][props.child]) {
            treeItem(_obj[i][props.child], checkData);
          }
        }
      }

      for (var i in checkedNodes) {
        if (checkedNodes[i].type === 'user') {
          treeItem(props.treeData, checkedNodes[i]);
        }
      }

      if (init) {
        return _objectSpread({}, state, {
          componentProps: componentProps,
          _tree: (0, _tree.initData)({
            sourceList: treeData,
            props: componentProps
          })
        });
      } else {
        return _objectSpread({}, state, {
          componentProps: componentProps,
          updateCheckedNodes: updateCheckedNodes,
          updateIntermediateNodeKeys: updateIntermediateNodeKeys
        });
      }
    }
  }
};
exports.default = _default;