/* eslint-disable no-console, no-param-reassign, no-shadow  */
import React from 'react';
import ReactDOM from 'react-dom';
import { getAddress, getDepartUser } from './service/tree';
import { Tree } from './component.js';

const corpid = 'wx981d0202130ed8e7';
// const checkedNodes = [
//   {
//     deptId: '330108-S000018-D000002',
//     deptName: '所有老师',
//     type: 'user',
//     userId: 'FB37CA2221F7478BA3AFE9CCFF484F8E',
//     userName: '王辉',
//     userType: '',
//   },
// ];
const checkedNodes = [];
// const intermediateNodeKeys = [
//   '330108-S000018',
//   '405D2AE0E3FD5C01FC0B143C7D5A9760',
//   '330108-S000018-D000002',
// ];
const intermediateNodeKeys = [];
const disabledNodeKeys = [];

class Test extends React.Component {
  constructor(props) {
    super(props);

    this.treeRef = null;

    this.state = {
      sourceList: [],
    };
  }

  componentWillMount() {
    this.fetchTree();
  }

  filterNodes = originNodes => {
    const _nodes = originNodes.map(item => {
      const { type } = item;

      if (type === 'dept') {
        delete item.userId;
        delete item.userName;
        delete item.userType;
      } else if (type === 'user') {
        delete item.memberRole;
        delete item.deptType;
      }

      return item;
    });
    return _nodes;
  };

  handleConfirm = ({ checkedNodes = [], intermediateNodes = [] } = {}) => {
    const _checkedList = this.filterNodes(checkedNodes);
    const deptList = _checkedList.filter(item => item.type === 'dept');
    const userList = _checkedList.filter(item => item.type === 'user');
    this.filterNodes(intermediateNodes);
    console.log('​Test -> statichandleConfirm -> deptList', deptList);
    console.log('​Test -> statichandleConfirm -> userList', userList);
    console.log('​Test -> statichandleConfirm -> intermediateNodes', intermediateNodes);
    console.log('​Test -> statichandleConfirm -> checkedNodes', checkedNodes);
  };

  handleCancel = () => {
    console.log('点击了取消按钮');
  };

  fetchDepartUser = params => {
    const { deptId, deptType, deptName } = params;

    return getDepartUser({
      corpid,
      deptId,
      deptType,
    }).then(data => {
      const { users = [] } = data;
      return users.map(item => {
        const { userId, userName, userType = '' } = item;
        return {
          userId,
          userName,
          userType,
          deptId,
          deptName,
          deptType,
        };
      });
    });
  };

  fetchTree() {
    const requestParams = {
      haveAuthority: false,
      corpid,
    };
    getAddress(requestParams).then(data => {
      const treeData = data.rootDepartments;
      this.setState({
        sourceList: treeData,
      });
    });
  }

  render() {
    const checkedNodeProps = [
      'deptId',
      'deptName',
      'memberRole',
      'userId',
      'userName',
      'userType',
      'deptType',
    ];
    const nodeFoldDetailProps = ['deptId', 'deptName', 'deptType'];
    const { sourceList } = this.state;

    if (!sourceList.length) {
      return null;
    }

    return (
      <div style={{ height: '100%' }}>
        <Tree
          ref={ref => {
            this.treeRef = ref;
          }}
          treeData={sourceList}
          staticNodeLabel="deptName"
          dynamicNodeLabel="userName"
          staticNodeKey="deptId"
          dynamicNodeKey="userId"
          child="subDepts"
          platform="mobile" // pc/mobile
          // deptNodeCheckable={false}
          checkedNodeProps={checkedNodeProps}
          checkedNodes={checkedNodes}
          disabledNodeKeys={disabledNodeKeys}
          intermediateNodeKeys={intermediateNodeKeys}
          // loadData={null}
          nodeFoldDetailProps={nodeFoldDetailProps}
          // loopStyle="entire"
          loadData={this.fetchDepartUser}
          onCancel={this.handleCancel}
          onOk={this.handleConfirm}
        />
      </div>
    );
  }
}

ReactDOM.render(<Test />, document.getElementById('root'));
