/* eslint-disable no-console, no-param-reassign, no-shadow  */
import React from 'react';
import ReactDOM from 'react-dom';
import { getAddress, getDepartUser } from './service/tree';
import { Tree } from './component.js';
// import choose from './assets/image/choose_p.svg';

const corpid = 'wx981d0202130ed8e7';
const checkedNodes = [
  {
    deptId: '330108-S000018-D000002',
    deptName: '所有老师',
    type: 'user',
    userId: '03E4260C68AD4A41A2D2D3156110C461',
    userName: '张力敏',
    userType: '',
  },
  {
    deptId: '330108-S000018-D000002',
    deptName: '所有老师',
    type: 'user',
    userId: '04DA607795A04026BC391A7EA5ABB90B',
    userName: '周卓睿',
    userType: '',
  },
  {
    deptId: '330108-S000018-D000002',
    deptName: '所有老师',
    type: 'user',
    userId: '04DA607795A04026BC2332EA5ABB90C',
    userName: '李宁杰',
    userType: '',
  },
  {
    deptId: '330108-S000018-D000002',
    deptName: '所有老师',
    type: 'user',
    userId: '04DA607795A04026BC391A743ABB90D',
    userName: '王小健',
    userType: '',
  },
];
const intermediateNodeKeys = [
  '330108-S000018',
  '405D2AE0E3FD5C01FC0B143C7D5A9760',
  '330108-S000018-D000002',
];
// const checkedNodes = [];

// const intermediateNodeKeys = [];
const disabledNodeKeys = [];

class Test extends React.Component {
  constructor(props) {
    super(props);

    this.treeRef = null;

    this.state = {
      sourceList: [],
      dynamicUnCheckedId: '',
      uncheckNode: {},
      listLabel: [],
    };

    this.handleUnCheckedId = this.handleUnCheckedId.bind(this);
    this.handleNodeChange = this.handleNodeChange.bind(this);
  }

  componentWillMount() {
    this.fetchTree();
  }

  filterNodes = originNodes => {
    const _nodes = originNodes.map(item => {
      const { type } = item;

      if (type === 'dept') {
        delete item.userId;
        delete item.userName;
        delete item.userType;
      } else if (type === 'user') {
        delete item.memberRole;
        delete item.deptType;
      }

      return item;
    });
    return _nodes;
  };

  handleConfirm = ({ checkedNodes = [], intermediateNodes = [] } = {}) => {
    const _checkedList = this.filterNodes(checkedNodes);
    const deptList = _checkedList.filter(item => item.type === 'dept');
    const userList = _checkedList.filter(item => item.type === 'user');
    this.filterNodes(intermediateNodes);
    console.log('​Test -> statichandleConfirm -> deptList', deptList);
    console.log('​Test -> statichandleConfirm -> userList', userList);
    console.log('​Test -> statichandleConfirm -> intermediateNodes', intermediateNodes);
    console.log('​Test -> statichandleConfirm -> checkedNodes', checkedNodes);
  };

  handleCancel = () => {
    console.log('点击了取消按钮');
  };

  fetchDepartUser = params => {
    const { deptId, deptType, deptName } = params;

    return getDepartUser({
      corpid,
      deptId,
      deptType,
    }).then(data => {
      const { users = [] } = data;
      return users.map(item => {
        const { userId, userName, userType = '' } = item;
        return {
          userId,
          userName,
          userType,
          deptId,
          deptName,
          deptType,
        };
      });
    });
  };

  handleUnCheckedId() {
    this.setState({
      dynamicUnCheckedId: '4E8E34D52F4B4C23A3909CEA919CB4B8', // 滨江向日葵/小虫校区/教职工组/曾琴
    });
  }

  fetchTree() {
    // this.setState({
    //   sourceList: checkedNodes,
    //   listLabel: [...checkedNodes],
    // });
    const requestParams = {
      haveAuthority: false,
      corpid,
    };
    getAddress(requestParams).then(data => {
      const treeData = data.rootDepartments || [];
      this.setState({
        sourceList: treeData,
      });
    });
  }

  handleNodeDelete = (detail) => {
    this.setState({
      uncheckNode: detail,
    })
    const {listLabel} = this.state
    listLabel.map((item, index) => {
      if (detail && ((detail.type === 'user' && item.userId === detail.userId) || (detail.type === 'dept' && item.deptId === detail.deptId))) {
        listLabel.splice(index, 1)
      }
      return true
    })
    this.setState({
      listLabel,
    })
  }

  // 取消选中 回掉
  handleUncheck = () => {
    this.setState({
      uncheckNode: {},
    })
  }

  handleNodeChange = ({ checkedNodes }) => {
    this.setState({
      listLabel: checkedNodes,
    })
  }

  render() {
    const checkedNodeProps = [
      'deptId',
      'deptName',
      'memberRole',
      'userId',
      'userName',
      'userType',
      'deptType',
    ];
    const nodeFoldDetailProps = ['deptId', 'deptName', 'deptType'];
    const { sourceList, dynamicUnCheckedId, uncheckNode, listLabel } = this.state;

    if (!sourceList.length) {
      return null;
    }

    return (
      <div style={{ height: '100%' }}>
        <div>
          {
            listLabel.map((item, index) => {
              return <span key={`node-label-${index}`}><a onClick={this.handleNodeDelete.bind(this, item)}>{item.userName}</a>&nbsp;&nbsp;&nbsp;&nbsp;</span>
            })
          }
        </div>
        <Tree
          ref={ref => {
            this.treeRef = ref;
          }}
          treeData={sourceList}
          staticNodeLabel="deptName"
          dynamicNodeLabel="userName"
          staticNodeKey="deptId"
          dynamicNodeKey="userId"
          child="subDepts"
          platform="pc" // pc/mobile
          // deptNodeCheckable={false}
          checkedNodeProps={checkedNodeProps}
          checkedNodes={checkedNodes}
          disabledNodeKeys={disabledNodeKeys}
          intermediateNodeKeys={intermediateNodeKeys}
          // loadData={null}
          nodeFoldDetailProps={nodeFoldDetailProps}
          // loopStyle="entire"
          loadData={this.fetchDepartUser}
          onCancel={this.handleCancel}
          onOk={this.handleConfirm}
          dynamicUnCheckedId={dynamicUnCheckedId}
          onChange={this.handleNodeChange}
          uncheckNode={uncheckNode}
          callbackUncheck={this.handleUncheck}
          // themeColor="#fe892b"
          // themeImg={choose}
          // renderNodeText={(data) => {
          //   return <div>{data.deptName}</div>
          // }}
        />
        <p onClick={this.handleUnCheckedId}>改变dynamicUnCheckedId</p>
      </div>
    );
  }
}

ReactDOM.render(<Test />, document.getElementById('root'));
