import axios from 'axios';

const defaultOptions = {
  method: 'get',
};

// `withCredentials` indicates whether or not cross-site Access-Control requests
// should be made using credentials
axios.defaults.withCredentials = true;

export default (url, options = defaultOptions) => {
  return axios({
    url,
    ...options,
  }).then(response => {
    const { status } = response;
    if (status !== 200) {
      return Promise.reject(new Error(`http请求失败，状态码：${status}`));
    }

    const {
      data: { code, data },
    } = response;
    if (code !== 200) {
      return Promise.reject(new Error(`接口请求失败，状态码：${status}`));
    }

    return Promise.resolve(data);
  });
};
